// 
//

#include "stdafx.h"
#include "stdio.h"
#include "stdlib.h"
#include "..\common\WebUtil.h"

void MakeForm(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes);
void MakeFooter(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes);
int QueryValueString( char* pszSrc, char* pszKey, char* pszOutStr, int nOutStrLen );
BOOL MyGetFileName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen);
void MyGetPathName(char* pszSrcFilePath);
void MakeFile(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes, char* pszPath);
char* space( char* szBuf, int nNum );

void ErrorReturn(MyVarMem* pRes)
{
	pRes->Clear();
	pRes->Add(
		"Content-Type: text/html; Charset=Shift_JIS\r\n\r\n"
		"<html><head><title>CEHTTP listener</title></head>\n"
		"<body>Error</body>"
		"<html>");

}
//*****************************************************************************
//
// fhChx
//	@etail
//		CGI[gDoc[gzɂ邱ƂKvƂȂ܂
//		Ƃ ../<cgiroot>/cgi.cgiȂǂ͔F܂
//		Ăяoɂ..͎gȂ
//
//		ԓ͕KCRLFŉs܂B
//		sڂ́uContent-Type: vLqĂB
//
// ----------------------------------------------------------------------------
//
//	@param
//		MyHash*		pEnv		ϐ܂
//		MyVarMem*	pBody		POSTꂽꍇANGXg{fB܂
//		MyVarMem*	pRes		NCAgɕԂeǉ܂
//
//	@return
//		pResɋlߍ񂾃oCgԂĂB
//
//*****************************************************************************
int fnChx(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	char	work[MAX_PATH] = "";
	char	szPathInfo[MAX_PATH] = "";
	char	szSerchPath[MAX_PATH] = "";
	WIN32_FIND_DATA	wfd;

	char*	pszScriptName = pEnv->GetValue("SCRIPT_NAME");
	char*	pszDocumentRoot = pEnv->GetValue("DOCUMENT_ROOT");
	char*	pszPathTranslated = pEnv->GetValueI("PATH_TRANSLATED");
	char* p;

	WebUtil wu(pEnv, pBody, pRes);
	// ------------------------------------------------------------------------
	// wb_[o
	// ------------------------------------------------------------------------
	pRes->Add(
		"Content-Type: text/html; Charset=Shift_JIS\r\n\r\n"
		"<html>\n"
		"<head>\n"
		"<title>CEHTTP listener</title>\n"
		);

	pRes->Add( "<SCRIPT language=\"JavaScript\"><!--\n"
		"function del_cmd(file_cmd){\n"
		"res = confirm(\"DELETE! Are you sure?\");\n"
		"if(res == true){location.href=file_cmd}"
		"}\n"
		"//--></SCRIPT>\n"
		);

	pRes->Add(
		"</head>\n"
		"<body>\n"
		"<B><U>CEHTTP listener</U></B><br>\n"
		);

	// ȒPȃ`FbN
	if( pszScriptName == NULL ||
		strlen( pszScriptName ) > 128 ||
		pszDocumentRoot == NULL ||
		strlen( pszDocumentRoot ) > 128 ||
		pszPathTranslated == NULL ||
		strlen( pszPathTranslated ) > 128
		)
	{
		pRes->Add("BAD ENV.");
		MakeFooter(pEnv, pBody, pRes);
		return pRes->GetLength();
	}

	// ------------------------------------------------------------------------
	// fBNgۑ
	// ------------------------------------------------------------------------
	strcpy( szPathInfo, pEnv->GetValue("PATH_INFO") );

	// ftHg""Ȃ̂ŁÂƂ"/"ɂB
	if( strlen(szPathInfo) < 1 )
	{
		strcpy(szPathInfo, "/");
	}

	// ------------------------------------------------------------------------
	// t@C쐬
	// ------------------------------------------------------------------------

	if( 0 == strcmp( pEnv->GetValue("REQUEST_METHOD"), "POST" ) )
	{
		MakeFile(pEnv, pBody, pRes, pszPathTranslated);

		for( p = &szPathInfo[strlen(szPathInfo)-1];*p != '\0' && *p != '/'; p--) *p = '\0';
		pRes->Clear();
		pRes->Add( "Location: " );
		pRes->Add( pszScriptName );
		pRes->Add( szPathInfo );
		pRes->Add( "\r\n\r\n" );
		return pRes->GetLength();
	}

	// ------------------------------------------------------------------------
	// GET
	// ------------------------------------------------------------------------

	char cmd[10] = {0};

	QueryValueString( pEnv->GetValue("QUERY_STRING"), "cmd=", cmd, 9 );

	if( 0 == strcmp( cmd, "delete" ) )
	{
		TCHAR	tszSerchPath[MAX_PATH];
		MultiByteToWideChar(0, 0, pszPathTranslated, -1, tszSerchPath, MAX_PATH);
		// ------------------------------------------------------------------------
		// t@C̍폜
		// ------------------------------------------------------------------------
		DWORD dwFileAtt;

		dwFileAtt = GetFileAttributes( tszSerchPath );

		if( 0xFFFFFFFF == dwFileAtt )
		{
				pRes->Add("<p>Failed at GetFileAttributes.</p>");
				pRes->Add("</BODY></html>");
				return pRes->GetLength();
		}


		if( FILE_ATTRIBUTE_DIRECTORY & dwFileAtt )
		{
			if( 0 == RemoveDirectory( tszSerchPath ) )
			{
				pRes->Add("<p>Remove directory failed.</p>");
				pRes->Add(cmd);
				pRes->Add("</BODY></html>");
				return pRes->GetLength();
			}
		}
		else
		{
			if( 0 == DeleteFile(tszSerchPath) )
			{
				pRes->Add("<p>DeleteFile failed.</p>");
				pRes->Add("</BODY></html>");
				return pRes->GetLength();
			}
		}


		for( p = &szPathInfo[strlen(szPathInfo)-1];*p != '\0' && *p != '/'; p--) *p = '\0';
		pRes->Clear();
		pRes->Add( "Location: " );
		pRes->Add( pszScriptName );
		pRes->Add( szPathInfo );
		pRes->Add( "\r\n\r\n" );
 		return pRes->GetLength();


	}
	else if( 0 == strcmp( cmd, "makedir" ) )
	{
		// --------------------------------------------------------------------
		// fBNg̍쐬
		// --------------------------------------------------------------------
		TCHAR	tszFolderPath[MAX_PATH] = {0};
		char szFolderFullName[MAX_PATH] = {0};
		char szFolderName[64] = {0};

		wu.GetItem( "foldername", szFolderName, 62 );

		strncpy( szFolderFullName, pszPathTranslated, MAX_PATH - 64 - 4 );
		strcat( szFolderFullName, szFolderName );

		MultiByteToWideChar(0, 0, szFolderFullName, -1, tszFolderPath, MAX_PATH);

		if( 0 == CreateDirectory( tszFolderPath, NULL ) )
		{
			pRes->Add("<p>Create directory failed.</p>");
			pRes->Add("</BODY></html>");
			return pRes->GetLength();
		}
	}

	sprintf( work, "<B>%s</B><BR>\n", szPathInfo );
	pRes->Add(work);

	pRes->Add("<PRE>");

	// ------------------------------------------------------------------------
	// pX̍쐬
	// ------------------------------------------------------------------------
	strcpy( szSerchPath, pszPathTranslated );

	if( szSerchPath[strlen(szSerchPath)-1] != '\\' )
	{
		strcat( szSerchPath, "\\" );
	}
	strcat( szSerchPath, "*.*" );

	// ------------------------------------------------------------------------
	// ̃fBNg
	// ------------------------------------------------------------------------

	if( 0 != STRICMP(szPathInfo, "/") )
	{
		char	szUpPath[MAX_PATH];
		strcpy( szUpPath, szPathInfo);

		for( p = &szUpPath[strlen(szUpPath) - 2];*p != '\0' && *p != '/'; p--)
			*p = '\0';

		sprintf( work, "<a href=\"%s%s\">Parent Directory/</a><br>\n", pszScriptName, szUpPath);
		pRes->Add(work);
	}

	// ------------------------------------------------------------------------
	// s
	// ------------------------------------------------------------------------
	TCHAR	tszSerchPath[MAX_PATH] = {0};
	MultiByteToWideChar(0, 0, szSerchPath, -1, tszSerchPath, MAX_PATH);
	HANDLE hFile = FindFirstFile(tszSerchPath, &wfd);
				
	if(hFile != INVALID_HANDLE_VALUE)
	{
		char* pBuffer;
		pBuffer = (char*)MALLOC( 4096 );
		if( pBuffer != NULL )
		{
			MyVarMem vmDir, vmFile;
			do
			{
				char szFindName[MAX_PATH] = {0};
				char szSpace[256] = {0};
				FILETIME ftLocal = {0};
				SYSTEMTIME stLastWriteTime = {0};
				FileTimeToLocalFileTime( &wfd.ftLastWriteTime, &ftLocal );
				FileTimeToSystemTime( &ftLocal, &stLastWriteTime );

				WideCharToMultiByte(CP_ACP, 0, wfd.cFileName, -1, szFindName, MAX_PATH, NULL, NULL);

				// Directory
				if( 0 == STRICMP( szFindName, "." ) || 0 == STRICMP( szFindName, ".." ))
					continue;

				if( wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY )
				{
					// ----------------------------------------------------------------
					// Directory
					// ----------------------------------------------------------------
					sprintf( pBuffer, 
						"<img src=\"/images/folder.gif\">"
						"<a href=\"%s%s%s/\">%s/</a>"
						"%s"
						"%04d/%02d/%02d %02d:%02d:%02d   "
						"<a href=\"javascript:del_cmd('%s%s%s?cmd=delete');\">delete</a>\n"

						, pszScriptName, szPathInfo, szFindName, szFindName
						, space(szSpace, 39 - strlen(szFindName))
						, stLastWriteTime.wYear, stLastWriteTime.wMonth, stLastWriteTime.wDay, stLastWriteTime.wHour, stLastWriteTime.wMinute, stLastWriteTime.wSecond
						, pEnv->GetValueI("SCRIPT_NAME"), szPathInfo, szFindName );
					vmDir.Add( pBuffer );
				}
				else
				{
					// ----------------------------------------------------------------
					// File
					// ----------------------------------------------------------------

					sprintf( pBuffer, 
						"<img src=\"/images/file.gif\">"
						"<a href=\"%s%s\">%s</a>"
						"%s"
						"%10d.%dKB      %04d/%02d/%02d %02d:%02d:%02d  "
						
						, szPathInfo, szFindName, szFindName
						, space(szSpace, 20 - strlen(szFindName))
						, wfd.nFileSizeLow/1024, (wfd.nFileSizeLow%1024)/102
						, stLastWriteTime.wYear, stLastWriteTime.wMonth, stLastWriteTime.wDay, stLastWriteTime.wHour, stLastWriteTime.wMinute, stLastWriteTime.wSecond
						);
					vmFile.Add( pBuffer );

					sprintf( pBuffer, 
						"<a href=\"javascript:del_cmd('%s%s%s?cmd=delete');\">delete</a>\n"
						, pEnv->GetValueI("SCRIPT_NAME"), szPathInfo, szFindName );
					vmFile.Add( pBuffer );
				}
			}while(FindNextFile(hFile, &wfd));
			FREE( pBuffer );
			pRes->Add( vmDir );
			pRes->Add( "<HR>" );
			pRes->Add( vmFile );
		}
	}

	pRes->Add("</PRE>");

	FindClose(hFile);

	// ------------------------------------------------------------------------
	// tH[̍쐬
	// ------------------------------------------------------------------------
	// t@CAbv[h
	pRes->Add( "<form method=\"post\" action=\"" );
	pRes->Add( pEnv->GetValueI("SCRIPT_NAME") );
	pRes->Add( szPathInfo );
	pRes->Add( "\" enctype=\"multipart/form-data\">\n" );
	pRes->Add( "<input type=\"file\" name=\"file_name\">\n" );
	pRes->Add( "<input type=\"submit\" name=\"Submit\" value=\"File upload\">\n" );
	pRes->Add( "</form>\n");

	// tH_̍쐬
	pRes->Add( "<form method=\"get\" action=\"" );
	pRes->Add( pEnv->GetValueI("SCRIPT_NAME") );
	pRes->Add( szPathInfo );
	pRes->Add( "\">\n" );
	pRes->Add( "<input type=\"text\" name=\"foldername\">\n" );
	pRes->Add( "<input type=\"hidden\" name=\"cmd\" value=\"makedir\">\n" );
	pRes->Add( "<input type=\"submit\" name=\"Submit\" value=\"Make directory\">\n" );
	pRes->Add( "</form>\n");


	MakeFooter(pEnv, pBody, pRes);

	return pRes->GetLength();

}

int QueryValueString( char* pszSrc, char* pszKey, char* pszOutStr, int nOutStrLen )
{

	int	ii;
	if( pszSrc == NULL )
	{
		*pszOutStr = '\0';
		return 0;
	}
	char* value = strstr( pszSrc, pszKey);

	if( NULL == value )
		return FALSE;
	
	char* tmp = value;
	while( *tmp++ != '=' );

	if( nOutStrLen == 0 )
	{
		for(ii = 0; *tmp != '&' && *tmp != '\0'; ii++, tmp++ );
		return ii;
	}

	for(ii = 0; *tmp != '&' && *tmp != '\0' && ii < nOutStrLen; ii++ )
	{
		pszOutStr[ii] = *tmp++;
	}
	pszOutStr[ii] = '\0';
	
	return ii;
}

BOOL MyGetFileName(char* pszSrcFilePath, char* pszDstFileName, int nFileNameLen)
{
	// "c:\xxxx\xxxx\xxxx.abc"
	char* p = pszSrcFilePath;

	if( *p == '\"' )
		return FALSE;

	// pEndŌ܂Ői߂
	while( *p != '\"' && *p != '\0' && *p != '\"' )
		p++;

	//*p = '\0';
	p--;

	while( *p != '\\' && *p != '\0' && *p != '\"' )
		p--;

	p++;

	while( *p != '\"' && *p != '\0' )
		*pszDstFileName++ = *p++;

	*pszDstFileName = '\0';

	return TRUE;
}

void MyGetPathName(char* pszSrcFilePath)
{
	// "c:\xxxx\xxxx\xxxx.abc"
	char* p = pszSrcFilePath + 1;

	// pEndŌ܂Ői߂
	while( /**p != '\"' &&*/ *p != '\0' )
		p++;

	//*p = '\0';
	p--;

	while( *p != '/' && *p != '\0' )
		p--;

	p++;
	*p = '\0';
}

void MakeFile(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes, char* pszPath)
{
	if( pszPath == NULL )
		return;

	// ------------------------------------------------------------------------
	// BODY̎擾
	// ------------------------------------------------------------------------
	char* pszContentLength = pEnv->GetValueI("CONTENT_LENGTH");
	if( pszContentLength == NULL )
	{
		pRes->Add("<p>CONTENT_LENGTH is not specified.</p>");
		return;
	}

	int nContentLength = atoi( pszContentLength );

	// ------------------------------------------------------------------------
	// oE_擾
	// ------------------------------------------------------------------------
	char* pszContentType = pEnv->GetValueI("CONTENT_TYPE");
	if( pszContentType == NULL )
	{
		pRes->Add("<p>CONTENT_TYPE is not specified.</p>");
		return;
	}

	char* pszBoundary = strstr(pszContentType, "boundary=");
	if( pszBoundary == NULL )
	{
		pRes->Add("<p>boundary is not specified.</p>");
		return;
	}

	pszBoundary += 9;		// strlen("boundary=") == 9
	int nBoundaryLen = strlen(pszBoundary);

	if( nContentLength <= nBoundaryLen )
	{
		pRes->Add("<p>It is not normal boundary size or CONTENT_LENGTH.</p>");
		return;
	}

	// ------------------------------------------------------------------------
	// t@CT
	// ------------------------------------------------------------------------
	char* pContent = (char*)pBody->GetBuffer();
	char* p1stBodyTop = (char*)pBody->GetBuffer();
	char* p2ndBodyTop = NULL;
	char* pFileName = NULL;

	for( ; p1stBodyTop + nBoundaryLen +2 < pContent + nContentLength; p1stBodyTop++ )
	{
		if( memcmp(p1stBodyTop, pszBoundary, nBoundaryLen) == 0 )
		{
			// ڂ̃oE_
			p1stBodyTop += nBoundaryLen;

			// '--' ͏Ï
			if( *(p1stBodyTop) == '-' && *(p1stBodyTop + 1) == '-' )
				return;

			p1stBodyTop+=2;	// \r\n


			p2ndBodyTop = p1stBodyTop + 1;

			while(1)
			{
				// over flow check.
				if( p2ndBodyTop + nBoundaryLen +2 > pContent + nContentLength )
				{
					pRes->Add("Bad conetnts length.<BR>");
					return;
				}

				// ̃oE_
				if( memcmp(p2ndBodyTop, pszBoundary, nBoundaryLen) == 0 )
					break;

				p2ndBodyTop++;
			}

			p2ndBodyTop -= 4;		// '\r\n--'

			// ----------------------------------------------------------------
			// oE_Ԃ̃p[g
			// ɃRs[
			// ----------------------------------------------------------------
			int nPartLen = p2ndBodyTop - p1stBodyTop;
			char* pPart = new char[nPartLen + 1];
			if( pPart == NULL )
			{
				pRes->Add("<p>Memroy alloc error.</p>");
				return;
			}

			memset( pPart, 0 , nPartLen+1 );
			memcpy( pPart, p1stBodyTop, nPartLen );
			
			char* pszNameTag = strstr( pPart, "name=\"file_name\"" );
			char* pszFilePath= strstr( pPart, "filename=\"" );

			if( pszNameTag == NULL || pszFilePath == NULL )
			{
				delete pPart;
				continue;
			}

			pszFilePath += 10;		// 'file_name=' length is 10

			char szFileName[MAX_PATH] = {0};

			// ------------------------------------------------------
			// t@C؂o
			// ------------------------------------------------------
			if( MyGetFileName( pszFilePath, szFileName, MAX_PATH) == FALSE )
			{
				pRes->Add("<p>Bad File Name.</p>");
				delete pPart;
				continue;
			}
			else
			{
				// --------------------------------------------------
				// 쐬ׂt@CB
				// --------------------------------------------------
				char*	pFileTop;
				DWORD	dwFileSize = 0;
				DWORD	dwNumberOfBytesWritten;
				char	szMakeFile[MAX_PATH];
				TCHAR	tszPath[MAX_PATH];

				strcpy( szMakeFile, pszPath );
				if( szMakeFile[strlen(szMakeFile)-1] != '/' )
					strcat( szMakeFile, "/");
				strcat( szMakeFile, szFileName);

				pRes->Add("Create file: ");
				pRes->Add( szFileName );
				pRes->Add("<BR>");

				MultiByteToWideChar(0, 0, szMakeFile, -1, tszPath, MAX_PATH);

				pFileTop = strstr( pPart, "\r\n\r\n" );
				pFileTop += 4;	// \r\n\r\n
				dwFileSize = (pPart+nPartLen) - pFileTop;


				if( dwFileSize > 0 )
				{
					HANDLE f = CreateFile(tszPath, GENERIC_WRITE,NULL, NULL,CREATE_ALWAYS, 0, NULL);

					if( pFileTop != NULL)
					{
						if( WriteFile( f, pFileTop, dwFileSize, &dwNumberOfBytesWritten, NULL ) )
						{
							pRes->Add("<p>Created.</p>");
						}
						else
						{
							pRes->Add("<p>WriteFile failed.</p>");
						}
					}
					CloseHandle(f);
				}
				else
				{
					pRes->Add("<p>Size 0 file.</p>");
				}
				delete pPart;
			}
		}
	}

}


char* space( char* szBuf, int nNum )
{
	if( nNum <= 0 )
	{
		*szBuf = '\0';
	}
	else
	{
		memset(szBuf, ' ', nNum);
		szBuf[nNum] = '\0';
	}
	return szBuf;
}

// ------------------------------------------------------------------------
// tb^[̍쐬
// ------------------------------------------------------------------------
void MakeFooter(MyHash* pEnv, MyVarMem* pBody, MyVarMem* pRes)
{
	pRes->Add("<HR><ADDRESS>");
	pRes->Add(pEnv->GetValue("SERVER_SOFTWARE"));
	pRes->Add("</ADDRESS></BODY></html>");

}


//*****************************************************************************
//
// DllMain
//
//*****************************************************************************
BOOL APIENTRY DllMain(
	HANDLE hModule, DWORD  ul_reason_for_call, LPVOID lpReserved )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

